//
//  smith.c
//
//  Created by Julien-Pierre Avrous on 22/08/06.
//  Copyright 2006 SourceMac.com. All rights reserved.
//
//


#include "smith.h"
#include <stdio.h>

/*
 => Prototypes fonctions privees <=
*/
unsigned long sum(unsigned long n);
unsigned long sumDecompose(unsigned long nbr);

/*
 => Fonction publique d'appelle <=
*/
unsigned nb_smith(unsigned long n)
{
  unsigned long k;
  if (!n)
    return 0;

  k=sumDecompose(n);
  if (k==sum(n))
    return k;

  return 0;
}


/*
 => Fonctions Privees <= 
*/
/* Somme des chiffres d'un nombre : par division et modulo par 10 */
unsigned long sum(unsigned long n)
{
  register unsigned long kn=n, sm=0;

  while (kn>0)
    {
      sm+=kn % 10;
      kn /= 10;
    }
  return sm;
}

/* Somme de la decomposition : on decompose (par division successive de nombre impaire), puis on additionne 
au fur et a mesure de la decomposition */
unsigned long sumDecompose(unsigned long n)
{
  register unsigned long ret=0;
  register unsigned long a=n, b, c;

  while (a%2==0)
    {
      ret+=2;
      a/=2;
      if (a==1)
	return ret;
    }
  b=3;
  c=a/2;
  while (1)
    {
      if (b>=c)
	{
	  ret+=sum(a);
	  return ret;
	}
      if (a%b==0)
	{
	  ret+=sum(b);
	  a/=b;
	  c=a/2;
	}
      else
	b+=2;
    }
  return ret;
}
